Foreman - Refactor #28565

Don't use AR's association_scope
12/24/2019 06:07 PM - Anonymous

Status: Closed
Priority: Normal
Assignee: Tomer Brisker
Category: Rails
Target version:
Difficulty: Fixed in Releases: 2.0.0
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/7318
Description

association_scope is private in Rails 6 (since https:/github.com/rails/rails/commit/Ob4cfa2ba3e978386240e0e562a409616cc32fd02):

[...]
NoMethodError: private method “association_scope' called for #<ActiveRecord::Associations::HasMany
Association:0x00000000100e57£8>

lib/core_extensions.rb:41:in “block in before_destroy'

lib/core_extensions.rb:40:in “each'

lib/core_extensions.rb:40:in “before_destroy'

[...]

Related issues:
Related to Foreman - Bug #11188: on deleting a capsule: Operation FAILED: ER... Closed
Blocks Foreman - Tracker #24837: Rails 6.0 Tracker Closed

Associated revisions

Revision bcfbba25 - 01/01/2020 05:04 PM - Tomer Brisker

Fixes #28565 - Avoid association_scope method

ActiveRecord::Associations#association_scope has been changed to private
method in Rails 6. We replace it by explicitly creating the

AssociationScope we need.

Additionally, refactored EnsureNotUsedBy callback to be more efficient

by only loading the authorized associations' ids once instead of loading

all of the records again for every existing association still present.

History

#1 - 12/24/2019 06:08 PM - Anonymous

- Related to Bug #11188: on deleting a capsule: Operation FAILED: ERROR: update or delete on table "smart_proxies" violates foreign key
constraint "hosts_puppet_ca_proxy_id_fk" on table "hosts" added

#2 - 12/24/2019 06:09 PM - Anonymous
- Blocks Tracker #24837: Rails 6.0 Tracker added

#3 - 01/01/2020 01:38 PM - Tomer Brisker
- Status changed from New to Assigned

- Assignee set to Tomer Brisker

#4 - 01/01/2020 02:25 PM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/7318 added
https://github.com/rails/rails/commit/0b4cfa2ba3e978386240e0e56a409616cc32fd02

#5 - 01/01/2020 05:04 PM - The Foreman Bot
- Fixed in Releases 2.0.0 added

#6 - 01/01/2020 06:01 PM - Tomer Brisker
- Status changed from Ready For Testing to Closed

Applied in changeset bctbba25d945t7777abb60b31ce96c3ee7383549.
